import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 14.08.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private int[] m = {1,2,5,10,20,50,100,200};

  private JLabel jLabel1 = new JLabel();
  private JTextField jTextField1 = new JTextField();
  private String[] jList1Data = {};
  private JButton jButton1 = new JButton();
  private JLabel jLabel2 = new JLabel();
  private JTextField jTextField2 = new JTextField();

  private JScrollPane jScrollPane1 = new JScrollPane();
    private JTextArea jTextArea1 = new JTextArea("");
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 300;
    int frameHeight = 314;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel1.setBounds(32, 16, 110, 16);
    jLabel1.setText("Betrag in Cent:");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel1);
    jTextField1.setBounds(152, 8, 73, 24);
    jTextField1.setText("8");
    cp.add(jTextField1);
    jButton1.setBounds(152, 232, 115, 25);
    jButton1.setText("Wechseln");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);

    jLabel2.setBounds(32, 216, 59, 16);
    jLabel2.setText("Anzahl:");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    jTextField2.setBounds(16, 232, 105, 24);
    jTextField2.setText("");
    cp.add(jTextField2);
    jScrollPane1.setBounds(8, 32, 273, 177);
    cp.add(jScrollPane1);
    jTextArea1.setText("");
    jTextArea1.setBounds(14, 6, 185, 89);
    jScrollPane1.setViewportView(jTextArea1);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public int wechselAnzahl(int b, int k)
  {
    if (k == 0)
      return 1;
    else {
      if (b < m[k])
        return wechselAnzahl(b,k-1);
      else
        return wechselAnzahl(b-m[k],k) + wechselAnzahl(b,k-1);
    }
  }

  public void wechselMoeglichkeiten(int b, int k, String w)
  {
    if (b == 0)
      jTextArea1.append(w+"\n");
    else {
      if (w.length() > 0)
        w = w + "+";
      for (int i = k; i>=0; i--)
        if (b >= m[i])
          wechselMoeglichkeiten(b-m[i], i, w + m[i]);

    }
  }

  public void jButton1_ActionPerformed(ActionEvent evt)
  {
    jTextArea1.setText("");
    wechselMoeglichkeiten(Integer.parseInt(jTextField1.getText()), 7, "");
    jTextField2.setText(""+wechselAnzahl(Integer.parseInt(jTextField1.getText()), 7));
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
